No Description
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

mass_deploy.sh 4.3KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151
  1. #!/bin/bash
  2. conffile="[@]LODEL2_CONFDIR[@]/mass_deploy.cfg"
  3. badconf() {
  4. echo -e "Either the file $conffile cannot be found or it didn't contains expected informations\n\nThe conffile is expected to define MONGODB_ADMIN_USER and MONGODB_ADMIN_PASSWORD variables" >&2
  5. exit 1
  6. }
  7. mongodb_connfail() {
  8. echo -e "Credential from $conffile seems to be incorrect. Unable to connect on admin db" >&2
  9. exit 2
  10. }
  11. usage() {
  12. echo -e "Usage : $0 (N|purgedb|-h|--help) [FIXED_NAME]
  13. \tWith :
  14. \t\t- N the number of instances to create
  15. \t\t- purgedb is to remove all created mongodb db\n"
  16. }
  17. slim_fails() {
  18. if [ -z "$1" ]
  19. then
  20. echo "SLIM fails for some reason. Abording..." >&2
  21. else
  22. echo "SLIM fails when $1. Abording...." >&2
  23. fi
  24. echo "It can be a good idea to run '$0 purgedb' and 'slim -p' now that mass_deploy just crashed. Those commands should be able to clean the mess ;)"
  25. exit 1
  26. }
  27. fixed_name="$2"
  28. test -f $conffile || badconf
  29. #Load conffile
  30. . $conffile
  31. test -z "$MONGODB_ADMIN_USER" && badconf
  32. test -z "$MONGODB_ADMIN_PASSWORD" && badconf
  33. if [ -z "$fixed_name" ]
  34. then
  35. #Check for the presence of /usr/share/dict/words to generate random names
  36. if [ -f '/usr/share/dict/words' ]
  37. then
  38. echo "/usr/share/dict/words found. Using this file as source for random names"
  39. random_name=$(sed -nE 's/^([A-Za-z0-9]+)$/\1/p' /usr/share/dict/words |shuf|head -n1)
  40. else
  41. echo -e "\n\n\tWarning... /usr/share/dict/words not found using \$RANDOM for random names generation"
  42. random_name=$RANDOM
  43. fi
  44. else
  45. random_name="$fixed_name"
  46. fi
  47. #Check for the presence of mongo and its conf
  48. if hash mongo 2>/dev/null
  49. then
  50. echo "Mongo found"
  51. else
  52. echo "You need mongo on this host to do a mass deploy !" >&2
  53. exit
  54. fi
  55. if [ -f "/etc/mongodb.conf" ]
  56. then
  57. if cat /etc/mongodb.conf |grep -E '^ *auth *= *true *$' >/dev/null
  58. then
  59. echo "OK, auth enabled"
  60. else
  61. echo "WARNING : auth seems disabled on mongod !" >&2
  62. fi
  63. else
  64. echo "/etc/mongodb.conf not found. Unable to check if auth is on"
  65. fi
  66. echo "exit" | mongo $MONGODB_HOST --quiet -u "$MONGODB_ADMIN_USER" -p "$MONGODB_ADMIN_PASSWORD" admin &>/dev/null || mongodb_connfail
  67. if [ "$1" == 'purgedb' ]
  68. then
  69. if [ -z "$MONGODB_DB_PREFIX" ]
  70. then
  71. echo -e "MONGODB_DB_PREFIX not indicated in $conffile. Using purgedb without prefix is really a bad idea... It will result in a deletion of ALL db.\nexiting."
  72. exit 3
  73. fi
  74. echo -n "Are you sure you want to delete all mongo database with name begining with '$MONGODB_DB_PREFIX' ? Y/n "
  75. read rep
  76. if [ "$rep" = "Y" ]
  77. then
  78. for dbname in $(echo "show dbs" | mongo -u admin -p pass admin |grep "^$MONGODB_DB_PREFIX"|cut -f1)
  79. do
  80. echo -e "use $dname\ndb.dropDatabase()\nexit\n" | mongo -u $MONGODB_ADMIN_USER -p $MONGODB_ADMIN_PASSWORD --quiet --authenticationDatabase admin $dbname && echo "$dbname succesfully deleted" || echo "$dbname deletion fails" >&2
  81. done
  82. echo "Done."
  83. else
  84. echo "You didn't answer 'Y' (case matters), exiting"
  85. fi
  86. exit
  87. elif echo $1 | grep -E "[A-Za-z]" &>/dev/null
  88. then
  89. usage
  90. exit 0
  91. fi
  92. #Check for the presence of pwgen for password generation
  93. if hash pwgen 2>/dev/null
  94. then
  95. echo "Using pwgen to generate passwords"
  96. rnd_pass_cmd='pwgen 25 1'
  97. else
  98. echo -e "\n\n\tpwgen not found... Using \$RANDOM to generate passwords\n\n"
  99. rnd_pass_cmd='echo $RANDOM'
  100. fi
  101. ninstance=$1
  102. instance=${ninstance:=50}
  103. echo -n "You are going to create $ninstance lodel2 instances. Are you sure ? Y/n "
  104. read rep
  105. if [ "$rep" = "Y" ]
  106. then
  107. echo "GO ! (you have 3 secs to cancel)"
  108. sleep 3
  109. else
  110. echo "You didn't answer 'Y' (case matters), exiting"
  111. exit
  112. fi
  113. echo "Creating instances"
  114. for i in $(seq $ninstance)
  115. do
  116. iname="${random_name}_$(printf "%05d" $i)"
  117. slim -n $iname -c || slim_fails "creating instance"
  118. slim -n $iname -s --interface web --static-url 'http://127.0.0.1/static' --uwsgi-workers 2 || slim_fails "configuring instancee"
  119. slim -n $iname -m || slim_fails "running make in instance"
  120. #Mongo db database creation
  121. dbname="${MONGODB_DB_PREFIX}_$iname"
  122. dbuser="lodel2_$iname"
  123. dbpass=$($rnd_pass_cmd)
  124. mongo $MONGODB_HOST -u "$MONGODB_ADMIN_USER" -p "$MONGODB_ADMIN_PASSWORD" admin <<EOF
  125. use $dbname
  126. db.addUser({user:"$dbuser", pwd:"$dbpass", roles:["readWrite", "dbAdmin"]})
  127. exit
  128. EOF
  129. #Append created db to instance conf
  130. slim -n $iname -s --datasource_connectors mongodb --host localhost --user $dbuser --password $dbpass --db_name $dbname || slim_fails "configuring the instance's datasource"
  131. done